// Agent.cpp: implementation of the Agent class.
//
//////////////////////////////////////////////////////////////////////

#include "Agent.h"


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////


Agent::Agent()
{
	Agent::invItem_ptr = AgentInventory; //points at a given item in Inventory array.
	Agent::funds = 1000; // each agent has 1200
	extern lastIssuedID;
		lastIssuedID += 1;// updates agent register
	Agent::agentID = lastIssuedID; //assigns an agent ID, NOTE: 1st agents ID is 1
	extern globalAgentList[];
		globalAgentList[lastIssuedID] = lastIssuedID; // Agent ID no indicates that an agent exists at this index
	extern no_of_agents;
		no_of_agents += 1;
}

Agent::~Agent()
{

}

void Agent::inventoryOptimise()
{
	// algorithm to ensure that no empty spaces are present in inventory array
	Agent::reset_invItem_ptr();
	
	Agent::invItem_ptr;
	Inventory* lastEmptySpace = NULL;
	bool noChange = true;
	bool repeatFlag = true;
	
	while 
	(repeatFlag == true)
	{
		repeatFlag = false;

		 for (int i=0; i <= 4; i++)
		 {
			 if ( (Agent::invItem_ptr->amount == 0) && (lastEmptySpace == NULL) && (noChange == true) )
			{
				// do nothing
			}
			else if ( (Agent::invItem_ptr->amount == 0) && (lastEmptySpace == NULL) && (noChange == false) )
			{
				// reassign pointer
				lastEmptySpace = Agent::invItem_ptr;			}
			else if ( (Agent::invItem_ptr->amount == 0) && (lastEmptySpace != NULL) )
			{
				repeatFlag = true;
			}
			else if ( (Agent::invItem_ptr->amount != 0) && (lastEmptySpace != NULL) )
			{
				// swap data
				lastEmptySpace->amount = Agent::invItem_ptr->amount;
				lastEmptySpace->value = Agent::invItem_ptr->value;
				strcpy(lastEmptySpace->desc, Agent::invItem_ptr->desc );

				// reassign pointer
				lastEmptySpace = Agent::invItem_ptr;

					
				noChange = false;
			}

			// move to next item
			Agent::invItem_ptr += 1;
		 }
	}
		


	/*
	Get current item.

	If (amt == 0) and (lastEmptySpace == NULL) then assign address to lastEmptySpace.
	{
		lastEmptySpace = currentSpace
		goto next item
	}
	else if (amt == 0) and (lastEmptySpace != NULL)
		problem cond; multiple spaces; some sort of flag; for now cout a message
		set repeat inventoryOptimise_flag to 1
	else if (amt != 0) and (lastEmptySpace != NULL)
	{
		switch with currentSpace with lastEmptySpace
		move to next item
	}
	else if (amt != 0) and (lastEmptySpace == NULL)
		Move to next item
	else
		cout << "Condition not catered for!"
		
	*/
	/*
	Agent::reset_invItem_ptr();

	Inventory* prevItem = Agent::invItem_ptr;
	for (int i = 1; i <=4; i++)
	{
		if(prevItem->amount != 0)
			inv
	}
	*/

}

int Agent::countInventory()
{
	// count how many items in inventory
	// assume that all inventory items are consequtive
	
	int itemNo = 0;

	Agent::reset_invItem_ptr(); // point at first item
	
	while ( (Agent::invItem_ptr->amount != 0) && (itemNo < 4) ) // can't have more than 4 items
	{
		// loop
		Agent::invItem_ptr += 1;
		itemNo += 1;
	}

	return itemNo;

}
Inventory* Agent::forsale()
{
	int choice = ( (rand()%3) + 1);

	Inventory* saleProd;

	switch (choice)
	{
		case 1: saleProd = Agent::cheapestItem();
				cout << "Looking for cheapest item" << endl;
				break;
		case 2: saleProd = Agent::dearestItem();
				cout << "Looking for dearest item" << endl;
				break;
		case 3: saleProd = Agent::plentifulItem();
				cout << "Looking for most plentiful item" << endl;
				break;
		default: cout << "Error in switch!";
				break;
	}

	Agent::belief_valueWorth = saleProd->value;

	cout << "Hi my name is " << Agent::name << endl;
	cout << "I have "
		<< saleProd->amount << " "
		 << saleProd->desc // troublesome line
		 << " for sale at $"  
		 << Agent::belief_valueWorth << "."<< endl;

	cout << "Any bidders?" << endl;

	//this code dynamically allocates memory storage to product description (not required)
	int lettNo = strlen(saleProd->desc);

	if(( Agent::currProd = (char *) malloc ((lettNo + 1) * sizeof(char)) ) == NULL)
	{
		cout << "Error allocating memory!" << endl;
		return NULL;
	}
	else
		strcpy(Agent::currProd, saleProd->desc);

	return saleProd;
}

int Agent::bid(double current_price)
{
	if (Agent::belief_valueWorth > current_price)
	{
		cout << Agent::name << " here. I am submitting a bid!   [$"
			 << current_price
			 << "]"<< endl;
		return 1; // indicates bid is submitted
	}
	else
	{
		cout << Agent::name << " here. Not intersted." << endl;
		return 0; // indicates bid is not tendered
		// In real scenario Agent would not state when he is not bidding.
	}
	
}

void Agent::move_invItem_ptr()
{
	// Agent::invItem_ptr = XXX;  points at invItem[0] by default

	// algorithm to move to most plentiful item
		// track value

	// algorithm to move to most expensive item
		// track amount
}

void Agent::agent1_init()
{
	Agent::nameAgent("Deco");
	Agent::belief_trust = 5;
	Agent::createProduct();
}

void Agent::agent2_init()
{
	Agent::nameAgent("Robo");
	Agent::belief_trust = 4;
	Agent::createProduct();
}


void Agent::agent3_init()
{
	Agent::nameAgent("Bren");
	Agent::belief_trust = 1;
	Agent::createProduct();
}

void Agent::agent4_init()
{
	Agent::nameAgent("Sean");
	Agent::belief_trust = 2;
	Agent::createProduct();	
}

void Agent::agent5_init()
{
	Agent::nameAgent("Kevi");
	Agent::belief_trust = 4;
	Agent::createProduct();	
}

void Agent::createProduct()
{
	/* Populating Invetory*/
	// i should let use step through inventory
	// This should really be encapsulated within Inventory class.


	for (int i=0; i<=3; i++) // i<= to populate full inventory
	{
		Agent::invItem_ptr = (AgentInventory + i); //points at a given item in Inventory array.

		Product newProd;
		Product* newProdPtr;
		newProdPtr = newProd.selectProduct();
		
		Agent::invItem_ptr->amount = newProdPtr->amount; // should point at the real variable
		Agent::invItem_ptr->value = newProdPtr->value;
		Agent::invItem_ptr->desc = newProdPtr->desc; // pointer simply reassigned
	}

	// populate last space with empty data
	Agent::invItem_ptr = (AgentInventory + 4);
	Agent::invItem_ptr->amount = 0;
	Agent::invItem_ptr->value = 0;
	Agent::invItem_ptr->desc = "";
}

// find empty inventory spot
Inventory* Agent::findEmptyInv()
{
	Agent::reset_invItem_ptr(); // initialise to first element
	for (int i=0; i<=5; i++)
	{
		if (i == 5)
		{
			cout << "Inventory full! Unable to find inventory space!!!" <<endl;
			return NULL; // full
		}
		else if (Agent::invItem_ptr->amount == 0) // if space free
			return (Agent::invItem_ptr);
		else
			Agent::invItem_ptr += 1;
	}
	return NULL;
}

void Agent::addItem(Inventory* pos, Inventory* currProdPtr)
{
	if (pos == NULL)
	{
		cout << "Unable to add item to inventory!!! Never recieved valid pointer."
			 << endl;
	}
	else
	{
		int descSize = strlen(currProdPtr->desc);
		if((pos->desc = (char*) malloc( descSize * sizeof(char) )) == NULL)
			cout << "Error allocating memory to pos->desc!!!" << endl;
		else
		{
			strcpy(pos->desc, currProdPtr->desc);
			pos->value = currProdPtr->value;
			pos->amount = currProdPtr->amount;
		}
		Agent::inventoryOptimise();
	}
}

void Agent::remItem(Inventory* pos)
{
		pos->amount = 0;
		strcpy(pos->desc, "");
		pos->value = 0;	
		Agent::inventoryOptimise();
}

int Agent::accept(double current_price)
{
	/*
	in a more realistic scenario this function could be used to let the seller check
	the buyers trust rating
	*/

	if (1)
		return 1; // bid accepted
	else
		return 0; // bid rejected
}

void Agent::reset_invItem_ptr()
{
	Agent::invItem_ptr = Agent::AgentInventory;
}

void Agent::displayInventory()
{
	Agent::reset_invItem_ptr();
	
	cout << endl
		 << "__________________________________________" << endl
		 <<"Agent ID: "<< Agent::getAgentID() << endl
		 <<"Name: " << Agent::getname() << endl
		 <<"Funds: " << Agent::getfunds() << endl
		 << "__________________________________________" << endl;

	for (int i = 0; i<=4; i++)
	{
		cout << endl
			 << "Desc: " << Agent::invItem_ptr->desc << endl
			 << "Amount: " << Agent::invItem_ptr->amount << endl
			 << "Value: " << Agent::invItem_ptr->value << endl
			 << "__________" << endl;
		Agent::invItem_ptr +=1;
	}
}

void Agent::nameAgent(const char *name)
{
	strcpy(Agent::name, name);
}

double Agent::decideValue(char* product)
{
	int temp = 0;
	// Agents will have a different range of bids depending on product being sold
	if ( strcmp(product, "Drum Kits") == 0)
	{
		do{ 	
			temp= rand()%1000; //1000 is maximum value possible
		}while (temp<140); //140 is minimum value possible
		if (temp > funds)
			return funds;
		else
			return temp;
	}
	else if ( strcmp(product, "Guitars") == 0)
	{
		do{ 	
			temp= rand()%500;
		}while (temp<80);
		if (temp > funds)
			return funds;
		else
			return temp;
	}
	else if ( strcmp(product, "Discmen") == 0)
	{
		do{ 	
			temp= rand()%1000;
		}while (temp<30); 
		if (temp > funds)
			return funds;
		else
			return temp;
	}
	else if ( strcmp(product, "Bikes") == 0)
	{
		do{ 	
			temp= rand()%450;
		}while (temp<70); 
		if (temp > funds)
			return funds;
		else
			return temp;
	}
	else if ( strcmp(product, "Cars") == 0)
	{
		do{ 	
			temp= rand()%2000;
		}while (temp<200); 
		if (temp > funds)
			return funds;
		else
			return temp;
	}
	else
	{
		cout << "Buyer doesn't have a record of this product in his inventory." 
			 << endl << "Somewhat confused and won't bid!!!" << endl;
		return 0;
	}
}

char* Agent::getname()
{
	return Agent::name;
}

double Agent::getfunds()
{
	return Agent::funds;
}

Inventory* Agent::get_invItem_ptr()
{
	return Agent::invItem_ptr;
}

Inventory* Agent::getAgentInvStart()
{
	// return pointer to first position in inventory
	return Agent::AgentInventory;
}

int Agent::getAgentID()
{
	return Agent::agentID;
}

void Agent::updateFunds(double finalPrice)
{
	// takes a negative no if subtracting
	Agent::funds += finalPrice;
}

Inventory* Agent::cheapestItem()
{
	int itemNo = Agent::countInventory();

	Agent::reset_invItem_ptr(); // point at first item

	// move to cheapest item
	Inventory* cheapestItem;

	cheapestItem = Agent::invItem_ptr;
	for (int i = 1; i <= itemNo; i++)
	{
		if (Agent::invItem_ptr->value > cheapestItem->value)
			cheapestItem = Agent::invItem_ptr;
		Agent::invItem_ptr += 1;
	}
	return cheapestItem;
}

Inventory* Agent::dearestItem()
{
	int itemNo = Agent::countInventory();

	Agent::reset_invItem_ptr(); // point at first item

	// move to most expensive item
	Inventory* dearestItem;

	dearestItem = Agent::invItem_ptr;
	for (int i = 1; i <= itemNo; i++)
	{
		if (Agent::invItem_ptr->value > dearestItem->value)
			dearestItem = Agent::invItem_ptr;
		Agent::invItem_ptr += 1;
	}
	return dearestItem;
}

Inventory* Agent::plentifulItem()
{
	int itemNo = Agent::countInventory();

	Agent::reset_invItem_ptr(); // point at first item

	// move to most plentiful item
	Inventory* plentifulItem;

	plentifulItem = Agent::invItem_ptr;
	for (int i = 1; i <= itemNo; i++)
	{
		if (Agent::invItem_ptr->amount > plentifulItem->amount)
			plentifulItem = Agent::invItem_ptr;
		Agent::invItem_ptr += 1;
	}
	return plentifulItem;
}